#include <fpp.h>
#include <hash.h>

#if STDC
void
dodef2(const char *thename, const char *thevalue, int permanent)
#else /* NOT STDC */
void
dodef2(thename,thevalue,permanent)
const char *thename;
const char *thevalue;
int permanent;				/* 1 if permanent */
#endif /* STDC */
{
    int n;

    if (fpp_debug)
    {
	FPRINTF(stddbg,"%s:DEBUG: Macro: %s=%s\n",
		fpp_dbgprefix(), thename, thevalue);
	FFLUSH(stddbg);
    }

    if (PERMANENT(thename) && !permanent)
    {
	if (getdef(thename) != (const char *)NULL)
	{
	    error("Permanent symbol [", thename, "] cannot be redefined", 0);
	    return;
	}
    }

    n = install(thename,thevalue);

    if ((!PERMANENT(thename)) || (PERMANENT(thename) && !permanent))
	PRINTF("%s Macro: %s=%s\n",out_prefix,thename,thevalue);

    if (n < 0)
	error("Too many defined symbols", "", "", 0);
}
