#include <fpp.h>

#define P1 "fpp -- C version "
#define P2 VERSIONNUMBER
#define P3 " ["
#define P4 VERSIONDATE
#define P5 "]"

const char *
version(VOID_ARG)
{
    static char *v = (char*)NULL;
    size_t need;

    if (v == (char*)NULL)		/* only need to do this on the first call */
    {
	need = sizeof(P1) + sizeof(P2) + sizeof(P3) + sizeof(P4) + sizeof(P5) + 1;
	v = (char*)malloc(need);
	if (v == (char*)NULL)
	{
	    char buffer[sizeof("18446744073709551615")+1]; /* 2^64 - 1 */
	    (void)sprintf(buffer,"%lu",(unsigned long)need);
	    error("Out of memory in version(): [", buffer, " bytes requested]", 0);
	    exit(EXIT_FAILURE);
	}
	sprintf(v,"%s%s%s%s%s", P1, P2, P3, P4, P5);
    }
    return ((const char*)v);
}
