#if !defined(XSTDLIB_H)
#define XSTDLIB_H

#include <args.h>			/* for ARGS() and STDC definitions */

#if defined(HAVE_DIR_H)
#include <dir.h>			/* for getcwd() prototype */
#endif

#if defined(HAVE_LIBC_H)
#include <libc.h>
#endif

#if defined(HAVE_STDDEF_H)
#include <stddef.h>
#endif

#if defined(HAVE_STDLIB_H)
#include <stdlib.h>
#endif

#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif

/* Supply declarations for a few library functions that are often
absent from system header files.  These are all defined as C
functions, even in a C++ environment.  */

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

#if !defined(HAVE_ACCESS_PROTOTYPE)
int			access ARGS((const char *path_, int amode_));
#endif

#if !defined(HAVE_GETENV_PROTOTYPE)
char			*getenv ARGS((const char *envvar_));
#endif

#if !defined(HAVE_GETCWD_PROTOTYPE)
char			*getcwd ARGS((char *buf_, int size_));
#if defined(HAVE_GETWD_PROTOTYPE)
#define getcwd(buf,size) getwd(buf_)
#endif
#endif

#if !defined(HAVE_GETHOSTNAME_PROTOTYPE)
int			gethostname ARGS((char *name_, size_t namelen_));
#endif

#if !defined(HAVE_GETLOGIN_PROTOTYPE)
char			*getlogin ARGS((void));
#endif

#if !defined(HAVE_GETPWNAM_PROTOTYPE)
struct passwd		*getpwnam ARGS((const char* name_));
#endif

#if !defined(HAVE_GETPWUID_PROTOTYPE)
struct passwd		*getpwuid ARGS((uid_t uid_));
#endif

#if !defined(HAVE_GETWD_PROTOTYPE)
char			*getwd ARGS((char *buf_));
#endif

#if !defined(HAVE_SLEEP_PROTOTYPE)
unsigned int		sleep ARGS((unsigned int seconds_));
#endif

#if !defined(HAVE_TMPNAM_PROTOTYPE)
char			*tmpnam(char * filename_);
#endif

#if defined(__cplusplus) || defined(c_plusplus)
};
#endif

#if !defined(EXIT_FAILURE)
#define EXIT_FAILURE	1
#endif

#if !defined(EXIT_SUCCESS)
#define EXIT_SUCCESS	0
#endif

#if defined(ABS)
#undef ABS
#endif
#define ABS(x)		(((x) < 0) ? (-(x)) : (x))

#if defined(MAX)
#undef MAX
#endif
#define MAX(a,b)	((a) < (b) ? (b) : (a))

#if defined(MIN)
#undef MIN
#endif
#define MIN(a,b)	((a) > (b) ? (b) : (a))

#endif /* !defined(XSTDLIB_H) */
